ACM学习历程—CodeForces 601A The Two Routes(最短路)

题目链接:http://codeforces.com/problemset/problem/601/A

题目大意是有铁路和陆路两种路,而且两种方式走的交通工具不能在中途相遇。

此外,有铁路的地方肯定没有陆路。

这种情况下就会有一个结论,就是至少有一种交通可以直接1到n。

这样只需要对另一种跑一个最短路就OK了。

代码:

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <string>
#define LL long long

using namespace std;

const int maxN = 405;
int n, m;
bool dis[maxN][maxN];
int p[maxN];
bool flag;
struct node
{
    int val;
    int id;
    bool operator<(node x) const
    {
        return val > x.val;
    }
};

void input()
{
    memset(dis, false, sizeof(dis));
    int u, v;
    for (int i = 0; i < m; ++i)
    {
        scanf("%d%d", &u, &v);
        dis[u][v] = dis[v][u] = true;
    }
    if (dis[1][n]) flag = false;
    else flag = true;
}

void work()
{
    memset(p, -1, sizeof(p));
    int ans = 1, u;
    node k, v;
    priority_queue<node> q;
    p[1] = 0;
    k.val = 0;
    k.id = 1;
    q.push(k);
    while (!q.empty())
    {
        k = q.top();
        q.pop();
        u = k.id;
        for (int i = 1; i <= n; ++i)
        {
            if (i == u) continue;
            if (dis[i][u] != flag) continue;
            if (p[i] == -1 || p[i] > p[u]+1)
            {
                p[i] = p[u]+1;
                k.id = i;
                k.val = p[i];
                q.push(k);
            }
        }
    }
    if (p[n] == -1) ans = -1;
    else ans = p[n];
    printf("%d\n", ans);
}

int main()
{
    //freopen("test.in", "r", stdin);
    while (scanf("%d%d", &n, &m) != EOF)
    {
        input();
        work();
    }
    return 0;
}

时间: 2024-10-16 21:05:18

ACM学习历程—CodeForces 601A The Two Routes(最短路)的相关文章

ACM学习历程—CodeForces 176B Word Cut(字符串匹配 &amp;&amp; dp &amp;&amp; 递推)

Description Let's consider one interesting word game. In this game you should transform one word into another through special operations. Let's say we have word w, let's split this word into two non-empty parts x and y so, that w = xy. A split operat

[ An Ac a Day ^_^ ] CodeForces 601A The Two Routes 最短路

14号就ccpc全国赛的全国赛了 而且也快东北赛的选拔赛了 现在队伍实力实在不行 参加了也是边缘化的队伍 虽然有新生保护的设置 但实话说 机会还是不大 所以不如趁现在开始好好努力 明年也许还有机会 An Ac a Day ( of course not keep a girl away ^_^ ) 题意呢 一个人开火车 一个人开大巴 火车走铁路 大巴走公路 现在有n个城镇 每两个城镇之间都有路 其中m条铁路 其他的都是公路 要求两个人都从1开始走 途中不相遇 问最快要多久 题面比较诡异 两个人

ACM学习历程—HDU 4726 Kia&#39;s Calculation( 贪心&amp;&amp;计数排序)

DescriptionDoctor Ghee is teaching Kia how to calculate the sum of two integers. But Kia is so careless and alway forget to carry a number when the sum of two digits exceeds 9. For example, when she calculates 4567+5789, she will get 9246, and for 12

ACM学习历程—HDU 5023 A Corrupt Mayor&#39;s Performance Art(广州赛区网赛)(线段树)

Problem Description Corrupt governors always find ways to get dirty money. Paint something, then sell the worthless painting at a high price to someone who wants to bribe him/her on an auction, this seemed a safe way for mayor X to make money. Becaus

ACM学习历程—UESTC 1226 Huatuo&#39;s Medicine(数学)(2015CCPC L)

题目链接:http://acm.uestc.edu.cn/#/problem/show/1226 题目就是构造一个对称的串,除了中间的那个只有1个,其余的两边都是对称的两个,自然答案就是2*n-1. 代码: #include <iostream> #include <cstdio> #include <cstdlib> #include <cmath> #include <cstring> #include <algorithm> #

CodeForces - 601A The Two Routes

http://codeforces.com/problemset/problem/601/A 这道题没想过来, 有点脑筋急转弯的感觉了 本质上就是找最短路径 但是卡在不能重复走同一个点 ---->>> 这是来坑人的 因为这是一个完全图(不是被road 连接  就是被rail连接 ) 所以一定有一条直接连1 和 n的路径 那么只用找没有连 1 和 n 的路径的 那个图的最短路即可 然后这个dijkstra写的是O(V^2)的写法 以后尽量用优先队列的写法O(ElogV) 1 #includ

ACM学习历程—BestCoder Round #75

1001:King's Cake(数论) http://acm.hdu.edu.cn/showproblem.php?pid=5640 这题有点辗转相除的意思.基本没有什么坑点. 代码: #include <iostream> #include <cstdio> #include <cstdlib> #include <cmath> #include <cstring> #include <algorithm> #include &l

ACM学习历程—HDU5637 Transform(数论 &amp;&amp; 最短路)

题目链接:http://codeforces.com/problemset/problem/590/A 题目大意是给两种操作,然后给你一个s,一个t,求s至少需要多少次操作到t. 考虑到第一种操作是将某一位取反,而第二种操作是抑或一个数. 显然第一种操作也是可以通过抑或一个数得到的.比如:第i位取反,相当于抑或(1<<i)这个数.于是就将n个数扩大到n+17就可以了,因为100000最多17位. 此外如果p^a^b^c...=q的话,那么a^b^c...=p^q.于是,只需要求出p^q至少需要

ACM学习历程—HDU5585 Numbers(数论 || 大数)(BestCoder Round #64 (div.2) 1001)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5585 题目大意就是求大数是否能被2,3,5整除. 我直接上了Java大数,不过可以对末尾来判断2和5,对所有位的和来判断3. 代码就不粘了.